-- 
-- Created by SQL::Translator::Producer::DB2
-- Created on Mon Jun 30 20:17:21 2008
-- 
CREATE TABLE build (
  id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL,
  siteid INTEGER NOT NULL DEFAULT 0,
  projectid INTEGER NOT NULL DEFAULT 0,
  stamp VARCHAR(255) NOT NULL DEFAULT '',
  name VARCHAR(255) NOT NULL DEFAULT '',
  type VARCHAR(255) NOT NULL DEFAULT '',
  generator VARCHAR(255) NOT NULL DEFAULT '',
  starttime TIMESTAMP NOT NULL DEFAULT '0001-01-01 00:00:00',
  endtime TIMESTAMP NOT NULL DEFAULT '0001-01-01 00:00:00',
  submittime TIMESTAMP NOT NULL DEFAULT '0001-01-01 00:00:00',
  command VARCHAR(65535) NOT NULL,
  log VARCHAR(65535) NOT NULL,
  PRIMARY KEY (id)
);

CREATE TABLE buildgroup (
  id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL,
  name VARCHAR(255) NOT NULL DEFAULT '',
  projectid INTEGER NOT NULL DEFAULT 0,
  starttime TIMESTAMP NOT NULL DEFAULT '0001-01-01 00:00:00',
  endtime TIMESTAMP NOT NULL DEFAULT '0001-01-01 00:00:00',
  description VARCHAR(65535) NOT NULL,
  PRIMARY KEY (id)
);

CREATE TABLE buildgroupposition (
  buildgroupid INTEGER NOT NULL DEFAULT 0,
  position INTEGER NOT NULL DEFAULT 0,
  starttime TIMESTAMP NOT NULL DEFAULT '0001-01-01 00:00:00',
  endtime TIMESTAMP NOT NULL DEFAULT '0001-01-01 00:00:00'
);

CREATE TABLE build2group (
  groupid INTEGER NOT NULL DEFAULT 0,
  buildid INTEGER NOT NULL DEFAULT 0,
  PRIMARY KEY (buildid)
);

CREATE TABLE build2grouprule (
  groupid INTEGER NOT NULL DEFAULT 0,
  buildtype VARCHAR(20) NOT NULL DEFAULT '',
  buildname VARCHAR(255) NOT NULL DEFAULT '',
  siteid INTEGER NOT NULL DEFAULT 0,
  expected SMALLINT NOT NULL DEFAULT 0,
  starttime TIMESTAMP NOT NULL DEFAULT '0001-01-01 00:00:00',
  endtime TIMESTAMP NOT NULL DEFAULT '0001-01-01 00:00:00'
);

CREATE TABLE builderror (
  buildid INTEGER NOT NULL DEFAULT 0,
  type SMALLINT NOT NULL DEFAULT 0,
  logline INTEGER NOT NULL DEFAULT 0,
  text VARCHAR(65535) NOT NULL,
  sourcefile VARCHAR(255) NOT NULL DEFAULT '',
  sourceline INTEGER NOT NULL DEFAULT 0,
  precontext VARCHAR(65535) NOT NULL,
  postcontext VARCHAR(65535) NOT NULL,
  repeatcount INTEGER NOT NULL DEFAULT 0
);

CREATE TABLE buildupdate (
  buildid INTEGER NOT NULL DEFAULT 0,
  starttime TIMESTAMP NOT NULL DEFAULT CURRENT TIMESTAMP,
  endtime TIMESTAMP NOT NULL DEFAULT '0001-01-01 00:00:00',
  command VARCHAR(65535) NOT NULL,
  type VARCHAR(4) NOT NULL DEFAULT '',
  status VARCHAR(65535) NOT NULL
);

CREATE TABLE configure (
  buildid INTEGER NOT NULL DEFAULT 0,
  starttime TIMESTAMP NOT NULL DEFAULT CURRENT TIMESTAMP,
  endtime TIMESTAMP NOT NULL DEFAULT '0001-01-01 00:00:00',
  command VARCHAR(65535) NOT NULL,
  log VARCHAR(65535) NOT NULL,
  status SMALLINT NOT NULL DEFAULT 0
);

CREATE TABLE coverage (
  buildid INTEGER NOT NULL DEFAULT 0,
  fileid INTEGER NOT NULL DEFAULT 0,
  covered SMALLINT NOT NULL DEFAULT 0,
  loctested INTEGER NOT NULL DEFAULT 0,
  locuntested INTEGER NOT NULL DEFAULT 0,
  branchstested INTEGER NOT NULL DEFAULT 0,
  branchsuntested INTEGER NOT NULL DEFAULT 0,
  functionstested INTEGER NOT NULL DEFAULT 0,
  functionsuntested INTEGER NOT NULL DEFAULT 0
);

CREATE TABLE coveragefile (
  id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL,
  fullpath VARCHAR(255) NOT NULL DEFAULT '',
  file BLOB,
  crc32 INTEGER DEFAULT NULL,
  PRIMARY KEY (id)
);

CREATE TABLE coveragefilelog (
  buildid INTEGER NOT NULL DEFAULT 0,
  fileid INTEGER NOT NULL DEFAULT 0,
  line INTEGER NOT NULL DEFAULT 0,
  code VARCHAR(10) NOT NULL DEFAULT ''
);

CREATE TABLE coveragesummary (
  buildid INTEGER NOT NULL DEFAULT 0,
  loctested INTEGER NOT NULL DEFAULT 0,
  locuntested INTEGER NOT NULL DEFAULT 0,
  PRIMARY KEY (buildid)
);

CREATE TABLE dynamicanalysis (
  id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL,
  buildid INTEGER NOT NULL DEFAULT 0,
  status VARCHAR(10) NOT NULL DEFAULT '',
  checker VARCHAR(60) NOT NULL DEFAULT '',
  name VARCHAR(255) NOT NULL DEFAULT '',
  path VARCHAR(255) NOT NULL DEFAULT '',
  fullcommandline VARCHAR(255) NOT NULL DEFAULT '',
  log VARCHAR(65535) NOT NULL,
  PRIMARY KEY (id)
);

CREATE TABLE dynamicanalysisdefect (
  dynamicanalysisid INTEGER NOT NULL DEFAULT 0,
  type VARCHAR(50) NOT NULL DEFAULT '',
  value VARCHAR(50) NOT NULL DEFAULT ''
);

CREATE TABLE image (
  id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL,
  img LONG VARCHAR FOR BIT DATA(4294967295) NOT NULL,
  extension VARCHAR(255) NOT NULL,
  checksum INTEGER NOT NULL
);

CREATE TABLE test2image (
  imgid INTEGER NOT NULL DEFAULT 0,
  testid INTEGER NOT NULL DEFAULT 0,
  role VARCHAR(255) NOT NULL,
  PRIMARY KEY (imgid, testid)
);

CREATE TABLE note (
  id BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL,
  text VARCHAR(16777215) NOT NULL,
  name VARCHAR(255) NOT NULL,
  crc32 INTEGER NOT NULL,
  PRIMARY KEY (id)
);

CREATE TABLE project (
  id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL,
  name VARCHAR(255) NOT NULL DEFAULT '',
  description VARCHAR(65535) NOT NULL,
  homeurl VARCHAR(255) NOT NULL DEFAULT '',
  cvsurl VARCHAR(255) NOT NULL DEFAULT '',
  bugtrackerurl VARCHAR(255) NOT NULL DEFAULT '',
  documentationurl VARCHAR(255) NOT NULL DEFAULT '',
  imageid INTEGER NOT NULL DEFAULT 0,
  public SMALLINT NOT NULL DEFAULT 1,
  coveragethreshold SMALLINT NOT NULL DEFAULT 70,
  nightlytime VARCHAR(50) NOT NULL DEFAULT '00:00:00',
  googletracker VARCHAR(50) NOT NULL DEFAULT '',
  emailbuildmissing SMALLINT NOT NULL DEFAULT 0,
  emaillowcoverage SMALLINT NOT NULL DEFAULT 0,
  emailtesttimingchanged SMALLINT NOT NULL DEFAULT 0,
  emailbrokensubmission SMALLINT NOT NULL DEFAULT 1,
  cvsviewertype VARCHAR(10) DEFAULT 'NULL',
  testtimestd FLOAT DEFAULT '4.0',
  testtimestdthreshold FLOAT DEFAULT '1.0',
  showtesttime SMALLINT DEFAULT 0,
  PRIMARY KEY (id)
);

CREATE TABLE site (
  id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL,
  name VARCHAR(255) NOT NULL DEFAULT '',
  ip VARCHAR(255) NOT NULL DEFAULT '',
  latitude VARCHAR(10) NOT NULL DEFAULT '',
  longitude VARCHAR(10) NOT NULL DEFAULT '',
  PRIMARY KEY (id)
);

CREATE TABLE siteinformation (
  siteid INTEGER NOT NULL,
  timestamp TIMESTAMP NOT NULL DEFAULT '0001-01-01 00:00:00',
  processoris64bits SMALLINT NOT NULL DEFAULT -1,
  processorvendor VARCHAR(255) NOT NULL DEFAULT 'NA',
  processorvendorid VARCHAR(255) NOT NULL DEFAULT 'NA',
  processorfamilyid INTEGER NOT NULL DEFAULT -1,
  processormodelid INTEGER NOT NULL DEFAULT -1,
  processorcachesize INTEGER NOT NULL DEFAULT -1,
  numberlogicalcpus SMALLINT NOT NULL DEFAULT -1,
  numberphysicalcpus SMALLINT NOT NULL DEFAULT -1,
  totalvirtualmemory INTEGER NOT NULL DEFAULT -1,
  totalphysicalmemory INTEGER NOT NULL DEFAULT -1,
  logicalprocessorsperphysical INTEGER NOT NULL DEFAULT -1,
  processorclockfrequency INTEGER NOT NULL DEFAULT -1,
  description VARCHAR(255) NOT NULL DEFAULT 'NA'
);

CREATE TABLE buildinformation (
  buildid INTEGER NOT NULL,
  osname VARCHAR(255) NOT NULL,
  osplatform VARCHAR(255) NOT NULL,
  osrelease VARCHAR(255) NOT NULL,
  osversion VARCHAR(255) NOT NULL,
  compilername VARCHAR(255) NOT NULL,
  compilerversion VARCHAR(20) NOT NULL,
  PRIMARY KEY (buildid)
);

CREATE TABLE site2user (
  siteid INTEGER NOT NULL DEFAULT 0,
  userid INTEGER NOT NULL DEFAULT 0
);

CREATE TABLE test (
  id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL,
  crc32 INTEGER NOT NULL,
  name VARCHAR(255) NOT NULL DEFAULT '',
  path VARCHAR(255) NOT NULL DEFAULT '',
  command VARCHAR(65535) NOT NULL,
  details VARCHAR(65535) NOT NULL,
  output VARCHAR(65535) NOT NULL,
  PRIMARY KEY (id)
);

CREATE TABLE build2test (
  buildid INTEGER NOT NULL DEFAULT 0,
  testid INTEGER NOT NULL DEFAULT 0,
  status VARCHAR(10) NOT NULL DEFAULT '',
  time FLOAT NOT NULL DEFAULT '0.00',
  timemean FLOAT NOT NULL DEFAULT '0.00',
  timestd FLOAT NOT NULL DEFAULT '0.00',
  timestatus SMALLINT NOT NULL DEFAULT 0
);

CREATE TABLE updatefile (
  buildid INTEGER NOT NULL DEFAULT 0,
  filename VARCHAR(255) NOT NULL DEFAULT '',
  checkindate TIMESTAMP NOT NULL DEFAULT CURRENT TIMESTAMP,
  author VARCHAR(255) NOT NULL DEFAULT '',
  email VARCHAR(255) NOT NULL DEFAULT '',
  log VARCHAR(65535) NOT NULL,
  revision VARCHAR(20) NOT NULL DEFAULT '0',
  priorrevision VARCHAR(20) NOT NULL DEFAULT '0'
);

CREATE TABLE user (
  id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL,
  email VARCHAR(255) NOT NULL DEFAULT '',
  password VARCHAR(40) NOT NULL DEFAULT '',
  firstname VARCHAR(40) NOT NULL DEFAULT '',
  lastname VARCHAR(40) NOT NULL DEFAULT '',
  institution VARCHAR(255) NOT NULL DEFAULT '',
  admin SMALLINT NOT NULL DEFAULT 0,
  PRIMARY KEY (id)
);

CREATE TABLE user2project (
  userid INTEGER NOT NULL DEFAULT 0,
  projectid INTEGER NOT NULL DEFAULT 0,
  role INTEGER NOT NULL DEFAULT 0,
  cvslogin VARCHAR(50) NOT NULL DEFAULT '',
  emailtype SMALLINT NOT NULL DEFAULT 0,
  PRIMARY KEY (userid, projectid)
);

CREATE TABLE buildnote (
  buildid INTEGER NOT NULL,
  userid INTEGER NOT NULL,
  note VARCHAR(16777215) NOT NULL,
  timestamp TIMESTAMP NOT NULL,
  status SMALLINT NOT NULL DEFAULT 0
);

CREATE TABLE repositories (
  id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL,
  url VARCHAR(255) NOT NULL,
  PRIMARY KEY (id)
);

CREATE TABLE project2repositories (
  projectid INTEGER NOT NULL,
  repositoryid INTEGER NOT NULL,
  PRIMARY KEY (projectid, repositoryid)
);

CREATE TABLE testmeasurement (
  testid BIGINT NOT NULL,
  name VARCHAR(70) NOT NULL,
  type VARCHAR(70) NOT NULL,
  value VARCHAR(65535) NOT NULL
);

CREATE TABLE dailyupdate (
  id BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL,
  projectid INTEGER NOT NULL,
  date DATE NOT NULL,
  command VARCHAR(65535) NOT NULL,
  type VARCHAR(4) NOT NULL DEFAULT '',
  status SMALLINT NOT NULL DEFAULT 0
);

CREATE TABLE dailyupdatefile (
  dailyupdateid INTEGER NOT NULL DEFAULT 0,
  filename VARCHAR(255) NOT NULL DEFAULT '',
  checkindate TIMESTAMP NOT NULL DEFAULT CURRENT TIMESTAMP,
  author VARCHAR(255) NOT NULL DEFAULT '',
  log VARCHAR(65535) NOT NULL,
  revision VARCHAR(10) NOT NULL DEFAULT '0',
  priorrevision VARCHAR(10) NOT NULL DEFAULT '0'
);

CREATE TABLE builderrordiff (
  buildid BIGINT NOT NULL,
  type SMALLINT NOT NULL,
  difference INTEGER NOT NULL
);

CREATE TABLE testdiff (
  buildid BIGINT NOT NULL,
  type SMALLINT NOT NULL,
  difference INTEGER NOT NULL
);

CREATE TABLE build2note (
  buildid BIGINT NOT NULL,
  noteid BIGINT NOT NULL,
  time TIMESTAMP NOT NULL DEFAULT CURRENT TIMESTAMP
);

CREATE INDEX siteid ON build ( siteid, name );

CREATE INDEX projectid ON build ( projectid );

CREATE INDEX projectid ON buildgroup ( projectid );

CREATE INDEX buildgroupid ON buildgroupposition ( buildgroupid );

CREATE INDEX groupid ON build2group ( groupid );

CREATE INDEX groupid ON build2grouprule ( groupid );

CREATE INDEX buildid ON builderror ( buildid );

CREATE INDEX buildid ON buildupdate ( buildid );

CREATE INDEX buildid ON configure ( buildid );

CREATE INDEX buildid ON coverage ( buildid );

CREATE INDEX fileid ON coverage ( fileid );

CREATE INDEX fullpath ON coveragefile ( fullpath );

CREATE INDEX crc32 ON coveragefile ( crc32 );

CREATE INDEX fileid ON coveragefilelog ( fileid );

CREATE INDEX buildid ON coveragefilelog ( buildid );

CREATE INDEX buildid ON dynamicanalysis ( buildid );

CREATE INDEX buildid ON dynamicanalysisdefect ( dynamicanalysisid );

CREATE INDEX id ON image ( id );

CREATE INDEX checksum ON image ( checksum );

CREATE INDEX crc32 ON note ( crc32 );

CREATE INDEX siteid ON siteinformation ( siteid, timestamp );

CREATE INDEX siteid ON site2user ( siteid );

CREATE INDEX userid ON site2user ( userid );

CREATE INDEX crc32 ON test ( crc32 );

CREATE INDEX name ON test ( name );

CREATE INDEX buildid ON build2test ( buildid );

CREATE INDEX testid ON build2test ( testid );

CREATE INDEX status ON build2test ( status );

CREATE INDEX timestatus ON build2test ( timestatus );

CREATE INDEX buildid ON updatefile ( buildid );

CREATE INDEX buildid ON buildnote ( buildid );

CREATE INDEX testid ON testmeasurement ( testid );

CREATE INDEX buildid ON dailyupdate ( id );

CREATE INDEX buildid ON dailyupdatefile ( dailyupdateid );

CREATE INDEX buildid ON builderrordiff ( buildid );

CREATE INDEX buildid ON testdiff ( buildid, type );

CREATE INDEX buildid ON build2note ( buildid, noteid );
