-- 
-- Created by SQL::Translator::Producer::Oracle
-- Created on Mon Jun 30 20:17:30 2008
-- 
-- We assume that default NLS_DATE_FORMAT has been changed
-- but we set it here anyway to be self-consistent.
ALTER SESSION SET NLS_DATE_FORMAT = 'YYYY-MM-DD HH24:MI:SS';

--
-- Table: testmeasurement
--

CREATE TABLE testmeasurement (
  testid number(20) NOT NULL,
  name varchar2(70) NOT NULL,
  type varchar2(70) NOT NULL,
  value clob NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: dailyupdate
--

CREATE SEQUENCE sq_dailyupdate_id;

CREATE TABLE dailyupdate (
  id number(11) NOT NULL,
  projectid number(11) NOT NULL,
  date_ date NOT NULL,
  command clob NOT NULL,
  type varchar2(4) DEFAULT '' NOT NULL,
  status number(4) DEFAULT '0' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: dailyupdatefile
--

CREATE TABLE dailyupdatefile (
  dailyupdateid number(11) DEFAULT '0' NOT NULL,
  filename varchar2(255) DEFAULT '' NOT NULL,
  checkindate date DEFAULT 'CURRENT_TIMESTAMP' NOT NULL,
  author varchar2(255) DEFAULT '' NOT NULL,
  log clob NOT NULL,
  revision varchar2(10) DEFAULT '0' NOT NULL,
  priorrevision varchar2(10) DEFAULT '0' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

CREATE OR REPLACE TRIGGER ai_dailyupdate_id
BEFORE INSERT ON dailyupdate
FOR EACH ROW WHEN (
 new.id IS NULL OR new.id = 0
)
BEGIN
 SELECT sq_dailyupdate_id.nextval
 INTO :new.id
 FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_dailyupdatefile_checkindate
BEFORE INSERT OR UPDATE ON dailyupdatefile
FOR EACH ROW WHEN (new.checkindate IS NULL)
BEGIN 
 SELECT sysdate INTO :new.checkindate FROM dual;
END;
/