-- 
-- Created by SQL::Translator::Producer::Oracle
-- Created on Mon Jun 30 20:17:28 2008
-- 
-- We assume that default NLS_DATE_FORMAT has been changed
-- but we set it here anyway to be self-consistent.
ALTER SESSION SET NLS_DATE_FORMAT = 'YYYY-MM-DD HH24:MI:SS';

--
-- Table: build
--

CREATE SEQUENCE sq_build_id;

CREATE TABLE build (
  id number(11) NOT NULL,
  siteid number(11) DEFAULT '0' NOT NULL,
  projectid number(11) DEFAULT '0' NOT NULL,
  stamp varchar2(255) DEFAULT '' NOT NULL,
  name varchar2(255) DEFAULT '' NOT NULL,
  type varchar2(255) DEFAULT '' NOT NULL,
  generator varchar2(255) DEFAULT '' NOT NULL,
  starttime date DEFAULT '0001-01-01 00:00:00' NOT NULL,
  endtime date DEFAULT '0001-01-01 00:00:00' NOT NULL,
  submittime date DEFAULT '0001-01-01 00:00:00' NOT NULL,
  command clob NOT NULL,
  log clob NOT NULL,
  PRIMARY KEY (id)
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: buildgroup
--

CREATE SEQUENCE sq_buildgroup_id;

CREATE TABLE buildgroup (
  id number(11) NOT NULL,
  name varchar2(255) DEFAULT '' NOT NULL,
  projectid number(11) DEFAULT '0' NOT NULL,
  starttime date DEFAULT '0001-01-01 00:00:00' NOT NULL,
  endtime date DEFAULT '0001-01-01 00:00:00' NOT NULL,
  description clob NOT NULL,
  PRIMARY KEY (id)
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: buildgroupposition
--

CREATE TABLE buildgroupposition (
  buildgroupid number(11) DEFAULT '0' NOT NULL,
  position number(11) DEFAULT '0' NOT NULL,
  starttime date DEFAULT '0001-01-01 00:00:00' NOT NULL,
  endtime date DEFAULT '0001-01-01 00:00:00' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: build2group
--

CREATE TABLE build2group (
  groupid number(11) DEFAULT '0' NOT NULL,
  buildid number(11) DEFAULT '0' NOT NULL,
  PRIMARY KEY (buildid)
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: build2grouprule
--

CREATE TABLE build2grouprule (
  groupid number(11) DEFAULT '0' NOT NULL,
  buildtype varchar2(20) DEFAULT '' NOT NULL,
  buildname varchar2(255) DEFAULT '' NOT NULL,
  siteid number(11) DEFAULT '0' NOT NULL,
  expected number(4) DEFAULT '0' NOT NULL,
  starttime date DEFAULT '0001-01-01 00:00:00' NOT NULL,
  endtime date DEFAULT '0001-01-01 00:00:00' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: builderror
--

CREATE TABLE builderror (
  buildid number(11) DEFAULT '0' NOT NULL,
  type number(4) DEFAULT '0' NOT NULL,
  logline number(11) DEFAULT '0' NOT NULL,
  text clob NOT NULL,
  sourcefile varchar2(255) DEFAULT '' NOT NULL,
  sourceline number(11) DEFAULT '0' NOT NULL,
  precontext clob NOT NULL,
  postcontext clob NOT NULL,
  repeatcount number(11) DEFAULT '0' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: buildupdate
--

CREATE TABLE buildupdate (
  buildid number(11) DEFAULT '0' NOT NULL,
  starttime date DEFAULT 'CURRENT_TIMESTAMP' NOT NULL,
  endtime date DEFAULT '0001-01-01 00:00:00' NOT NULL,
  command clob NOT NULL,
  type varchar2(4) DEFAULT '' NOT NULL,
  status clob NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: configure
--

CREATE TABLE configure (
  buildid number(11) DEFAULT '0' NOT NULL,
  starttime date DEFAULT 'CURRENT_TIMESTAMP' NOT NULL,
  endtime date DEFAULT '0001-01-01 00:00:00' NOT NULL,
  command clob NOT NULL,
  log clob NOT NULL,
  status number(4) DEFAULT '0' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: coverage
--

CREATE TABLE coverage (
  buildid number(11) DEFAULT '0' NOT NULL,
  fileid number(11) DEFAULT '0' NOT NULL,
  covered number(4) DEFAULT '0' NOT NULL,
  loctested number(11) DEFAULT '0' NOT NULL,
  locuntested number(11) DEFAULT '0' NOT NULL,
  branchstested number(11) DEFAULT '0' NOT NULL,
  branchsuntested number(11) DEFAULT '0' NOT NULL,
  functionstested number(11) DEFAULT '0' NOT NULL,
  functionsuntested number(11) DEFAULT '0' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: coveragefile
--

CREATE SEQUENCE sq_coveragefile_id;

CREATE TABLE coveragefile (
  id number(11) NOT NULL,
  fullpath varchar2(255) DEFAULT '' NOT NULL,
  file_ blob(65535),
  crc32 number(11) DEFAULT NULL,
  PRIMARY KEY (id)
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: coveragefilelog
--

CREATE TABLE coveragefilelog (
  buildid number(11) DEFAULT '0' NOT NULL,
  fileid number(11) DEFAULT '0' NOT NULL,
  line number(11) DEFAULT '0' NOT NULL,
  code varchar2(10) DEFAULT '' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: coveragesummary
--

CREATE TABLE coveragesummary (
  buildid number(11) DEFAULT '0' NOT NULL,
  loctested number(11) DEFAULT '0' NOT NULL,
  locuntested number(11) DEFAULT '0' NOT NULL,
  PRIMARY KEY (buildid)
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: dynamicanalysis
--

CREATE SEQUENCE sq_dynamicanalysis_id;

CREATE TABLE dynamicanalysis (
  id number(11) NOT NULL,
  buildid number(11) DEFAULT '0' NOT NULL,
  status varchar2(10) DEFAULT '' NOT NULL,
  checker varchar2(60) DEFAULT '' NOT NULL,
  name varchar2(255) DEFAULT '' NOT NULL,
  path varchar2(255) DEFAULT '' NOT NULL,
  fullcommandline varchar2(255) DEFAULT '' NOT NULL,
  log clob NOT NULL,
  PRIMARY KEY (id)
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: dynamicanalysisdefect
--

CREATE TABLE dynamicanalysisdefect (
  dynamicanalysisid number(11) DEFAULT '0' NOT NULL,
  type varchar2(50) DEFAULT '' NOT NULL,
  value varchar2(50) DEFAULT '' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: image
--

CREATE SEQUENCE sq_image_id;

CREATE TABLE image (
  id number(11) NOT NULL,
  img blob(4294967295) NOT NULL,
  extension varchar2(255) NOT NULL,
  checksum number(11) NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: test2image
--

CREATE TABLE test2image (
  imgid number(11) DEFAULT '0' NOT NULL,
  testid number(11) DEFAULT '0' NOT NULL,
  role varchar2(255) NOT NULL,
  PRIMARY KEY (imgid, testid)
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: note
--

CREATE SEQUENCE sq_note_id;

CREATE TABLE note (
  id number(20) NOT NULL,
  text clob NOT NULL,
  name varchar2(255) NOT NULL,
  crc32 number(11) NOT NULL,
  PRIMARY KEY (id)
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: project
--

CREATE SEQUENCE sq_project_id;

CREATE TABLE project (
  id number(11) NOT NULL,
  name varchar2(255) DEFAULT '' NOT NULL,
  description clob NOT NULL,
  homeurl varchar2(255) DEFAULT '' NOT NULL,
  cvsurl varchar2(255) DEFAULT '' NOT NULL,
  bugtrackerurl varchar2(255) DEFAULT '' NOT NULL,
  documentationurl varchar2(255) DEFAULT '' NOT NULL,
  imageid number(11) DEFAULT '0' NOT NULL,
  public_ number(4) DEFAULT '1' NOT NULL,
  coveragethreshold number(6) DEFAULT '70' NOT NULL,
  nightlytime varchar2(50) DEFAULT '00:00:00' NOT NULL,
  googletracker varchar2(50) DEFAULT '' NOT NULL,
  emailbuildmissing number(4) DEFAULT '0' NOT NULL,
  emaillowcoverage number(4) DEFAULT '0' NOT NULL,
  emailtesttimingchanged number(4) DEFAULT '0' NOT NULL,
  emailbrokensubmission number(4) DEFAULT '1' NOT NULL,
  cvsviewertype varchar2(10) DEFAULT NULL,
  testtimestd number(3, 1) DEFAULT '1',
  testtimestdthreshold number(3, 1) DEFAULT '1',
  showtesttime number(4) DEFAULT '0',
  PRIMARY KEY (id)
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: site
--

CREATE SEQUENCE sq_site_id;

CREATE TABLE site (
  id number(11) NOT NULL,
  name varchar2(255) DEFAULT '' NOT NULL,
  ip varchar2(255) DEFAULT '' NOT NULL,
  latitude varchar2(10) DEFAULT '' NOT NULL,
  longitude varchar2(10) DEFAULT '' NOT NULL,
  PRIMARY KEY (id)
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: siteinformation
--

CREATE TABLE siteinformation (
  siteid number(11) NOT NULL,
  timestamp date DEFAULT '0001-01-01 00:00:00' NOT NULL,
  processoris64bits number(4) DEFAULT '-1' NOT NULL,
  processorvendor varchar2(255) DEFAULT 'NA' NOT NULL,
  processorvendorid varchar2(255) DEFAULT 'NA' NOT NULL,
  processorfamilyid number(11) DEFAULT '-1' NOT NULL,
  processormodelid number(11) DEFAULT '-1' NOT NULL,
  processorcachesize number(11) DEFAULT '-1' NOT NULL,
  numberlogicalcpus number(4) DEFAULT '-1' NOT NULL,
  numberphysicalcpus number(4) DEFAULT '-1' NOT NULL,
  totalvirtualmemory number(11) DEFAULT '-1' NOT NULL,
  totalphysicalmemory number(11) DEFAULT '-1' NOT NULL,
  logicalprocessorsperphysical number(11) DEFAULT '-1' NOT NULL,
  processorclockfrequency number(11) DEFAULT '-1' NOT NULL,
  description varchar2(255) DEFAULT 'NA' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: buildinformation
--

CREATE TABLE buildinformation (
  buildid number(11) NOT NULL,
  osname varchar2(255) NOT NULL,
  osplatform varchar2(255) NOT NULL,
  osrelease varchar2(255) NOT NULL,
  osversion varchar2(255) NOT NULL,
  compilername varchar2(255) NOT NULL,
  compilerversion varchar2(20) NOT NULL,
  PRIMARY KEY (buildid)
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: site2user
--

CREATE TABLE site2user (
  siteid number(11) DEFAULT '0' NOT NULL,
  userid number(11) DEFAULT '0' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: test
--

CREATE SEQUENCE sq_test_id;

CREATE TABLE test (
  id number(11) NOT NULL,
  crc32 number(11) NOT NULL,
  name varchar2(255) DEFAULT '' NOT NULL,
  path varchar2(255) DEFAULT '' NOT NULL,
  command clob NOT NULL,
  details clob NOT NULL,
  output clob NOT NULL,
  PRIMARY KEY (id)
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: build2test
--

CREATE TABLE build2test (
  buildid number(11) DEFAULT '0' NOT NULL,
  testid number(11) DEFAULT '0' NOT NULL,
  status varchar2(10) DEFAULT '' NOT NULL,
  time number(7, 2) DEFAULT '1' NOT NULL,
  timemean number(7, 2) DEFAULT '1' NOT NULL,
  timestd number(7, 2) DEFAULT '1' NOT NULL,
  timestatus number(4) DEFAULT '0' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: updatefile
--

CREATE TABLE updatefile (
  buildid number(11) DEFAULT '0' NOT NULL,
  filename varchar2(255) DEFAULT '' NOT NULL,
  checkindate date DEFAULT 'CURRENT_TIMESTAMP' NOT NULL,
  author varchar2(255) DEFAULT '' NOT NULL,
  email varchar2(255) DEFAULT '' NOT NULL,
  log clob NOT NULL,
  revision varchar2(20) DEFAULT '0' NOT NULL,
  priorrevision varchar2(20) DEFAULT '0' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: user
--

CREATE SEQUENCE sq_user__id;

CREATE TABLE user_ (
  id number(11) NOT NULL,
  email varchar2(255) DEFAULT '' NOT NULL,
  password varchar2(40) DEFAULT '' NOT NULL,
  firstname varchar2(40) DEFAULT '' NOT NULL,
  lastname varchar2(40) DEFAULT '' NOT NULL,
  institution varchar2(255) DEFAULT '' NOT NULL,
  admin number(4) DEFAULT '0' NOT NULL,
  PRIMARY KEY (id)
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: user2project
--

CREATE TABLE user2project (
  userid number(11) DEFAULT '0' NOT NULL,
  projectid number(11) DEFAULT '0' NOT NULL,
  role number(11) DEFAULT '0' NOT NULL,
  cvslogin varchar2(50) DEFAULT '' NOT NULL,
  emailtype number(4) DEFAULT '0' NOT NULL,
  PRIMARY KEY (userid, projectid)
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: buildnote
--

CREATE TABLE buildnote (
  buildid number(11) NOT NULL,
  userid number(11) NOT NULL,
  note clob NOT NULL,
  timestamp date NOT NULL,
  status number(4) DEFAULT '0' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: repositories
--

CREATE SEQUENCE sq_repositories_id;

CREATE TABLE repositories (
  id number(11) NOT NULL,
  url varchar2(255) NOT NULL,
  PRIMARY KEY (id)
)
ENGINE    MyISAM
CHARACTER SET    latin1
AUTO_INCREMENT    1;

--
-- Table: project2repositories
--

CREATE TABLE project2repositories (
  projectid number(11) NOT NULL,
  repositoryid number(11) NOT NULL,
  PRIMARY KEY (projectid, repositoryid)
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: testmeasurement
--

CREATE TABLE testmeasurement (
  testid number(20) NOT NULL,
  name varchar2(70) NOT NULL,
  type varchar2(70) NOT NULL,
  value clob NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: dailyupdate
--

CREATE SEQUENCE sq_dailyupdate_id;

CREATE TABLE dailyupdate (
  id number(11) NOT NULL,
  projectid number(11) NOT NULL,
  date_ date NOT NULL,
  command clob NOT NULL,
  type varchar2(4) DEFAULT '' NOT NULL,
  status number(4) DEFAULT '0' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: dailyupdatefile
--

CREATE TABLE dailyupdatefile (
  dailyupdateid number(11) DEFAULT '0' NOT NULL,
  filename varchar2(255) DEFAULT '' NOT NULL,
  checkindate date DEFAULT 'CURRENT_TIMESTAMP' NOT NULL,
  author varchar2(255) DEFAULT '' NOT NULL,
  log clob NOT NULL,
  revision varchar2(10) DEFAULT '0' NOT NULL,
  priorrevision varchar2(10) DEFAULT '0' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: builderrordiff
--

CREATE TABLE builderrordiff (
  buildid number(20) NOT NULL,
  type number(4) NOT NULL,
  difference number(11) NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: testdiff
--

CREATE TABLE testdiff (
  buildid number(20) NOT NULL,
  type number(4) NOT NULL,
  difference number(11) NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

--
-- Table: build2note
--

CREATE TABLE build2note (
  buildid number(20) NOT NULL,
  noteid number(20) NOT NULL,
  time date DEFAULT 'CURRENT_TIMESTAMP' NOT NULL
)
ENGINE    MyISAM
CHARACTER SET    latin1;

CREATE OR REPLACE TRIGGER ai_build_id
BEFORE INSERT ON build
FOR EACH ROW WHEN (
 new.id IS NULL OR new.id = 0
)
BEGIN
 SELECT sq_build_id.nextval
 INTO :new.id
 FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_build_starttime
BEFORE INSERT OR UPDATE ON build
FOR EACH ROW WHEN (new.starttime IS NULL)
BEGIN 
 SELECT sysdate INTO :new.starttime FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_build_endtime
BEFORE INSERT OR UPDATE ON build
FOR EACH ROW WHEN (new.endtime IS NULL)
BEGIN 
 SELECT sysdate INTO :new.endtime FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_build_submittime
BEFORE INSERT OR UPDATE ON build
FOR EACH ROW WHEN (new.submittime IS NULL)
BEGIN 
 SELECT sysdate INTO :new.submittime FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ai_buildgroup_id
BEFORE INSERT ON buildgroup
FOR EACH ROW WHEN (
 new.id IS NULL OR new.id = 0
)
BEGIN
 SELECT sq_buildgroup_id.nextval
 INTO :new.id
 FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_buildgroup_starttime
BEFORE INSERT OR UPDATE ON buildgroup
FOR EACH ROW WHEN (new.starttime IS NULL)
BEGIN 
 SELECT sysdate INTO :new.starttime FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_buildgroup_endtime
BEFORE INSERT OR UPDATE ON buildgroup
FOR EACH ROW WHEN (new.endtime IS NULL)
BEGIN 
 SELECT sysdate INTO :new.endtime FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_buildgroupposition_starttim
BEFORE INSERT OR UPDATE ON buildgroupposition
FOR EACH ROW WHEN (new.starttime IS NULL)
BEGIN 
 SELECT sysdate INTO :new.starttime FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_buildgroupposition_endtime
BEFORE INSERT OR UPDATE ON buildgroupposition
FOR EACH ROW WHEN (new.endtime IS NULL)
BEGIN 
 SELECT sysdate INTO :new.endtime FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_build2grouprule_starttime
BEFORE INSERT OR UPDATE ON build2grouprule
FOR EACH ROW WHEN (new.starttime IS NULL)
BEGIN 
 SELECT sysdate INTO :new.starttime FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_build2grouprule_endtime
BEFORE INSERT OR UPDATE ON build2grouprule
FOR EACH ROW WHEN (new.endtime IS NULL)
BEGIN 
 SELECT sysdate INTO :new.endtime FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_buildupdate_starttime
BEFORE INSERT OR UPDATE ON buildupdate
FOR EACH ROW WHEN (new.starttime IS NULL)
BEGIN 
 SELECT sysdate INTO :new.starttime FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_buildupdate_endtime
BEFORE INSERT OR UPDATE ON buildupdate
FOR EACH ROW WHEN (new.endtime IS NULL)
BEGIN 
 SELECT sysdate INTO :new.endtime FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_configure_starttime
BEFORE INSERT OR UPDATE ON configure
FOR EACH ROW WHEN (new.starttime IS NULL)
BEGIN 
 SELECT sysdate INTO :new.starttime FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_configure_endtime
BEFORE INSERT OR UPDATE ON configure
FOR EACH ROW WHEN (new.endtime IS NULL)
BEGIN 
 SELECT sysdate INTO :new.endtime FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ai_coveragefile_id
BEFORE INSERT ON coveragefile
FOR EACH ROW WHEN (
 new.id IS NULL OR new.id = 0
)
BEGIN
 SELECT sq_coveragefile_id.nextval
 INTO :new.id
 FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ai_dynamicanalysis_id
BEFORE INSERT ON dynamicanalysis
FOR EACH ROW WHEN (
 new.id IS NULL OR new.id = 0
)
BEGIN
 SELECT sq_dynamicanalysis_id.nextval
 INTO :new.id
 FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ai_image_id
BEFORE INSERT ON image
FOR EACH ROW WHEN (
 new.id IS NULL OR new.id = 0
)
BEGIN
 SELECT sq_image_id.nextval
 INTO :new.id
 FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ai_note_id
BEFORE INSERT ON note
FOR EACH ROW WHEN (
 new.id IS NULL OR new.id = 0
)
BEGIN
 SELECT sq_note_id.nextval
 INTO :new.id
 FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ai_project_id
BEFORE INSERT ON project
FOR EACH ROW WHEN (
 new.id IS NULL OR new.id = 0
)
BEGIN
 SELECT sq_project_id.nextval
 INTO :new.id
 FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ai_site_id
BEFORE INSERT ON site
FOR EACH ROW WHEN (
 new.id IS NULL OR new.id = 0
)
BEGIN
 SELECT sq_site_id.nextval
 INTO :new.id
 FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_siteinformation_timestamp
BEFORE INSERT OR UPDATE ON siteinformation
FOR EACH ROW WHEN (new.timestamp IS NULL)
BEGIN 
 SELECT sysdate INTO :new.timestamp FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ai_test_id
BEFORE INSERT ON test
FOR EACH ROW WHEN (
 new.id IS NULL OR new.id = 0
)
BEGIN
 SELECT sq_test_id.nextval
 INTO :new.id
 FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_updatefile_checkindate
BEFORE INSERT OR UPDATE ON updatefile
FOR EACH ROW WHEN (new.checkindate IS NULL)
BEGIN 
 SELECT sysdate INTO :new.checkindate FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ai_user__id
BEFORE INSERT ON user_
FOR EACH ROW WHEN (
 new.id IS NULL OR new.id = 0
)
BEGIN
 SELECT sq_user__id.nextval
 INTO :new.id
 FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ai_repositories_id
BEFORE INSERT ON repositories
FOR EACH ROW WHEN (
 new.id IS NULL OR new.id = 0
)
BEGIN
 SELECT sq_repositories_id.nextval
 INTO :new.id
 FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ai_dailyupdate_id
BEFORE INSERT ON dailyupdate
FOR EACH ROW WHEN (
 new.id IS NULL OR new.id = 0
)
BEGIN
 SELECT sq_dailyupdate_id.nextval
 INTO :new.id
 FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_dailyupdatefile_checkindate
BEFORE INSERT OR UPDATE ON dailyupdatefile
FOR EACH ROW WHEN (new.checkindate IS NULL)
BEGIN 
 SELECT sysdate INTO :new.checkindate FROM dual;
END;
/

CREATE OR REPLACE TRIGGER ts_build2note_time
BEFORE INSERT OR UPDATE ON build2note
FOR EACH ROW WHEN (new.time IS NULL)
BEGIN 
 SELECT sysdate INTO :new.time FROM dual;
END;
/