-- 
-- Created by SQL::Translator::Producer::SQLServer
-- Created on Mon Jun 30 20:17:41 2008
-- 



--
-- Table: build
--

CREATE TABLE build (
  id int IDENTITY NOT NULL,
  siteid int NOT NULL DEFAULT '0',
  projectid int NOT NULL DEFAULT '0',
  stamp varchar(255) NOT NULL DEFAULT '',
  name varchar(255) NOT NULL DEFAULT '',
  type varchar(255) NOT NULL DEFAULT '',
  generator varchar(255) NOT NULL DEFAULT '',
  starttime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  endtime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  submittime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  command text NOT NULL,
  log text NOT NULL,
  CONSTRAINT pk_build PRIMARY KEY (id)
);

CREATE INDEX siteid ON build (siteid, name);

CREATE INDEX projectid ON build (projectid);



--
-- Table: buildgroup
--

CREATE TABLE buildgroup (
  id int IDENTITY NOT NULL,
  name varchar(255) NOT NULL DEFAULT '',
  projectid int NOT NULL DEFAULT '0',
  starttime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  endtime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  description text NOT NULL,
  CONSTRAINT pk_buildgroup PRIMARY KEY (id)
);

CREATE INDEX projectid ON buildgroup (projectid);



--
-- Table: buildgroupposition
--

CREATE TABLE buildgroupposition (
  buildgroupid int NOT NULL DEFAULT '0',
  position int NOT NULL DEFAULT '0',
  starttime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  endtime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00'
);

CREATE INDEX buildgroupid ON buildgroupposition (buildgroupid);



--
-- Table: build2group
--

CREATE TABLE build2group (
  groupid int NOT NULL DEFAULT '0',
  buildid int NOT NULL DEFAULT '0',
  CONSTRAINT pk_build2group PRIMARY KEY (buildid)
);

CREATE INDEX groupid ON build2group (groupid);



--
-- Table: build2grouprule
--

CREATE TABLE build2grouprule (
  groupid int NOT NULL DEFAULT '0',
  buildtype varchar(20) NOT NULL DEFAULT '',
  buildname varchar(255) NOT NULL DEFAULT '',
  siteid int NOT NULL DEFAULT '0',
  expected tinyint NOT NULL DEFAULT '0',
  starttime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  endtime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00'
);

CREATE INDEX groupid ON build2grouprule (groupid);



--
-- Table: builderror
--

CREATE TABLE builderror (
  buildid int NOT NULL DEFAULT '0',
  type tinyint NOT NULL DEFAULT '0',
  logline int NOT NULL DEFAULT '0',
  text text NOT NULL,
  sourcefile varchar(255) NOT NULL DEFAULT '',
  sourceline int NOT NULL DEFAULT '0',
  precontext text NOT NULL,
  postcontext text NOT NULL,
  repeatcount int NOT NULL DEFAULT '0'
);

CREATE INDEX buildid ON builderror (buildid);



--
-- Table: buildupdate
--

CREATE TABLE buildupdate (
  buildid int NOT NULL DEFAULT '0',
  starttime timestamp NOT NULL DEFAULT 'CURRENT_TIMESTAMP',
  endtime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  command text NOT NULL,
  type varchar(4) NOT NULL DEFAULT '',
  status text NOT NULL
);

CREATE INDEX buildid ON buildupdate (buildid);



--
-- Table: configure
--

CREATE TABLE configure (
  buildid int NOT NULL DEFAULT '0',
  starttime timestamp NOT NULL DEFAULT 'CURRENT_TIMESTAMP',
  endtime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  command text NOT NULL,
  log text NOT NULL,
  status tinyint NOT NULL DEFAULT '0'
);

CREATE INDEX buildid ON configure (buildid);



--
-- Table: coverage
--

CREATE TABLE coverage (
  buildid int NOT NULL DEFAULT '0',
  fileid int NOT NULL DEFAULT '0',
  covered tinyint NOT NULL DEFAULT '0',
  loctested int NOT NULL DEFAULT '0',
  locuntested int NOT NULL DEFAULT '0',
  branchstested int NOT NULL DEFAULT '0',
  branchsuntested int NOT NULL DEFAULT '0',
  functionstested int NOT NULL DEFAULT '0',
  functionsuntested int NOT NULL DEFAULT '0'
);

CREATE INDEX buildid ON coverage (buildid);

CREATE INDEX fileid ON coverage (fileid);



--
-- Table: coveragefile
--

CREATE TABLE coveragefile (
  id int IDENTITY NOT NULL,
  fullpath varchar(255) NOT NULL DEFAULT '',
  file blob(65535) NULL,
  crc32 int NULL DEFAULT NULL,
  CONSTRAINT pk_coveragefile PRIMARY KEY (id)
);

CREATE INDEX fullpath ON coveragefile (fullpath);

CREATE INDEX crc32 ON coveragefile (crc32);



--
-- Table: coveragefilelog
--

CREATE TABLE coveragefilelog (
  buildid int NOT NULL DEFAULT '0',
  fileid int NOT NULL DEFAULT '0',
  line int NOT NULL DEFAULT '0',
  code varchar(10) NOT NULL DEFAULT ''
);

CREATE INDEX fileid ON coveragefilelog (fileid);

CREATE INDEX buildid ON coveragefilelog (buildid);



--
-- Table: coveragesummary
--

CREATE TABLE coveragesummary (
  buildid int NOT NULL DEFAULT '0',
  loctested int NOT NULL DEFAULT '0',
  locuntested int NOT NULL DEFAULT '0',
  CONSTRAINT pk_coveragesummary PRIMARY KEY (buildid)
);



--
-- Table: dynamicanalysis
--

CREATE TABLE dynamicanalysis (
  id int IDENTITY NOT NULL,
  buildid int NOT NULL DEFAULT '0',
  status varchar(10) NOT NULL DEFAULT '',
  checker varchar(60) NOT NULL DEFAULT '',
  name varchar(255) NOT NULL DEFAULT '',
  path varchar(255) NOT NULL DEFAULT '',
  fullcommandline varchar(255) NOT NULL DEFAULT '',
  log text NOT NULL,
  CONSTRAINT pk_dynamicanalysis PRIMARY KEY (id)
);

CREATE INDEX buildid ON dynamicanalysis (buildid);



--
-- Table: dynamicanalysisdefect
--

CREATE TABLE dynamicanalysisdefect (
  dynamicanalysisid int NOT NULL DEFAULT '0',
  type varchar(50) NOT NULL DEFAULT '',
  value varchar(50) NOT NULL DEFAULT ''
);

CREATE INDEX buildid ON dynamicanalysisdefect (dynamicanalysisid);



--
-- Table: image
--

CREATE TABLE image (
  id int IDENTITY NOT NULL,
  img longblob(4294967295) NOT NULL,
  extension tinytext(255) NOT NULL,
  checksum int NOT NULL
);

CREATE INDEX id ON image (id);

CREATE INDEX checksum ON image (checksum);



--
-- Table: test2image
--

CREATE TABLE test2image (
  imgid int NOT NULL DEFAULT '0',
  testid int NOT NULL DEFAULT '0',
  role tinytext(255) NOT NULL,
  CONSTRAINT pk_test2image PRIMARY KEY (imgid, testid)
);



--
-- Table: note
--

CREATE TABLE note (
  id bigint IDENTITY NOT NULL,
  text mediumtext(16777215) NOT NULL,
  name varchar(255) NOT NULL,
  crc32 int NOT NULL,
  CONSTRAINT pk_note PRIMARY KEY (id)
);

CREATE INDEX crc32 ON note (crc32);



--
-- Table: project
--

CREATE TABLE project (
  id int IDENTITY NOT NULL,
  name varchar(255) NOT NULL DEFAULT '',
  description text NOT NULL,
  homeurl varchar(255) NOT NULL DEFAULT '',
  cvsurl varchar(255) NOT NULL DEFAULT '',
  bugtrackerurl varchar(255) NOT NULL DEFAULT '',
  documentationurl varchar(255) NOT NULL DEFAULT '',
  imageid int NOT NULL DEFAULT '0',
  public_ tinyint NOT NULL DEFAULT '1',
  coveragethreshold smallint NOT NULL DEFAULT '70',
  nightlytime varchar(50) NOT NULL DEFAULT '00:00:00',
  googletracker varchar(50) NOT NULL DEFAULT '',
  emailbuildmissing tinyint NOT NULL DEFAULT '0',
  emaillowcoverage tinyint NOT NULL DEFAULT '0',
  emailtesttimingchanged tinyint NOT NULL DEFAULT '0',
  emailbrokensubmission tinyint NOT NULL DEFAULT '1',
  cvsviewertype varchar(10) NULL DEFAULT NULL,
  testtimestd float(3,1) NULL DEFAULT '4.0',
  testtimestdthreshold float(3,1) NULL DEFAULT '1.0',
  showtesttime tinyint NULL DEFAULT '0',
  CONSTRAINT pk_project PRIMARY KEY (id)
);



--
-- Table: site
--

CREATE TABLE site (
  id int IDENTITY NOT NULL,
  name varchar(255) NOT NULL DEFAULT '',
  ip varchar(255) NOT NULL DEFAULT '',
  latitude varchar(10) NOT NULL DEFAULT '',
  longitude varchar(10) NOT NULL DEFAULT '',
  CONSTRAINT pk_site PRIMARY KEY (id)
);



--
-- Table: siteinformation
--

CREATE TABLE siteinformation (
  siteid int NOT NULL,
  timestamp timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  processoris64bits tinyint NOT NULL DEFAULT '-1',
  processorvendor varchar(255) NOT NULL DEFAULT 'NA',
  processorvendorid varchar(255) NOT NULL DEFAULT 'NA',
  processorfamilyid int NOT NULL DEFAULT '-1',
  processormodelid int NOT NULL DEFAULT '-1',
  processorcachesize int NOT NULL DEFAULT '-1',
  numberlogicalcpus tinyint NOT NULL DEFAULT '-1',
  numberphysicalcpus tinyint NOT NULL DEFAULT '-1',
  totalvirtualmemory int NOT NULL DEFAULT '-1',
  totalphysicalmemory int NOT NULL DEFAULT '-1',
  logicalprocessorsperphysical int NOT NULL DEFAULT '-1',
  processorclockfrequency int NOT NULL DEFAULT '-1',
  description varchar(255) NOT NULL DEFAULT 'NA'
);

CREATE INDEX siteid ON siteinformation (siteid, timestamp);



--
-- Table: buildinformation
--

CREATE TABLE buildinformation (
  buildid int NOT NULL,
  osname varchar(255) NOT NULL,
  osplatform varchar(255) NOT NULL,
  osrelease varchar(255) NOT NULL,
  osversion varchar(255) NOT NULL,
  compilername varchar(255) NOT NULL,
  compilerversion varchar(20) NOT NULL,
  CONSTRAINT pk_buildinformation PRIMARY KEY (buildid)
);



--
-- Table: site2user
--

CREATE TABLE site2user (
  siteid int NOT NULL DEFAULT '0',
  userid int NOT NULL DEFAULT '0'
);

CREATE INDEX siteid ON site2user (siteid);

CREATE INDEX userid ON site2user (userid);



--
-- Table: test
--

CREATE TABLE test (
  id int IDENTITY NOT NULL,
  crc32 int NOT NULL,
  name varchar(255) NOT NULL DEFAULT '',
  path varchar(255) NOT NULL DEFAULT '',
  command text NOT NULL,
  details text NOT NULL,
  output text NOT NULL,
  CONSTRAINT pk_test PRIMARY KEY (id)
);

CREATE INDEX crc32 ON test (crc32);

CREATE INDEX name ON test (name);



--
-- Table: build2test
--

CREATE TABLE build2test (
  buildid int NOT NULL DEFAULT '0',
  testid int NOT NULL DEFAULT '0',
  status varchar(10) NOT NULL DEFAULT '',
  time float(7,2) NOT NULL DEFAULT '0.00',
  timemean float(7,2) NOT NULL DEFAULT '0.00',
  timestd float(7,2) NOT NULL DEFAULT '0.00',
  timestatus tinyint NOT NULL DEFAULT '0'
);

CREATE INDEX buildid ON build2test (buildid);

CREATE INDEX testid ON build2test (testid);

CREATE INDEX status ON build2test (status);

CREATE INDEX timestatus ON build2test (timestatus);



--
-- Table: updatefile
--

CREATE TABLE updatefile (
  buildid int NOT NULL DEFAULT '0',
  filename varchar(255) NOT NULL DEFAULT '',
  checkindate timestamp NOT NULL DEFAULT 'CURRENT_TIMESTAMP',
  author varchar(255) NOT NULL DEFAULT '',
  email varchar(255) NOT NULL DEFAULT '',
  log text NOT NULL,
  revision varchar(20) NOT NULL DEFAULT '0',
  priorrevision varchar(20) NOT NULL DEFAULT '0'
);

CREATE INDEX buildid ON updatefile (buildid);



--
-- Table: user_
--

CREATE TABLE user_ (
  id int IDENTITY NOT NULL,
  email varchar(255) NOT NULL DEFAULT '',
  password varchar(40) NOT NULL DEFAULT '',
  firstname varchar(40) NOT NULL DEFAULT '',
  lastname varchar(40) NOT NULL DEFAULT '',
  institution varchar(255) NOT NULL DEFAULT '',
  admin tinyint NOT NULL DEFAULT '0',
  CONSTRAINT pk_user PRIMARY KEY (id)
);



--
-- Table: user2project
--

CREATE TABLE user2project (
  userid int NOT NULL DEFAULT '0',
  projectid int NOT NULL DEFAULT '0',
  role int NOT NULL DEFAULT '0',
  cvslogin varchar(50) NOT NULL DEFAULT '',
  emailtype tinyint NOT NULL DEFAULT '0',
  CONSTRAINT pk_user2project PRIMARY KEY (userid, projectid)
);



--
-- Table: buildnote
--

CREATE TABLE buildnote (
  buildid int NOT NULL,
  userid int NOT NULL,
  note mediumtext(16777215) NOT NULL,
  timestamp datetime NOT NULL,
  status tinyint NOT NULL DEFAULT '0'
);

CREATE INDEX buildid ON buildnote (buildid);



--
-- Table: repositories
--

CREATE TABLE repositories (
  id int IDENTITY NOT NULL,
  url varchar(255) NOT NULL,
  CONSTRAINT pk_repositories PRIMARY KEY (id)
);



--
-- Table: project2repositories
--

CREATE TABLE project2repositories (
  projectid int NOT NULL,
  repositoryid int NOT NULL,
  CONSTRAINT pk_project2repositories PRIMARY KEY (projectid, repositoryid)
);



--
-- Table: testmeasurement
--

CREATE TABLE testmeasurement (
  testid bigint NOT NULL,
  name varchar(70) NOT NULL,
  type varchar(70) NOT NULL,
  value text NOT NULL
);

CREATE INDEX testid ON testmeasurement (testid);



--
-- Table: dailyupdate
--

CREATE TABLE dailyupdate (
  id bigint IDENTITY NOT NULL,
  projectid int NOT NULL,
  date datetime NOT NULL,
  command text NOT NULL,
  type varchar(4) NOT NULL DEFAULT '',
  status tinyint NOT NULL DEFAULT '0'
);

CREATE INDEX buildid ON dailyupdate (id);



--
-- Table: dailyupdatefile
--

CREATE TABLE dailyupdatefile (
  dailyupdateid int NOT NULL DEFAULT '0',
  filename varchar(255) NOT NULL DEFAULT '',
  checkindate timestamp NOT NULL DEFAULT 'CURRENT_TIMESTAMP',
  author varchar(255) NOT NULL DEFAULT '',
  log text NOT NULL,
  revision varchar(10) NOT NULL DEFAULT '0',
  priorrevision varchar(10) NOT NULL DEFAULT '0'
);

CREATE INDEX buildid ON dailyupdatefile (dailyupdateid);



--
-- Table: builderrordiff
--

CREATE TABLE builderrordiff (
  buildid bigint NOT NULL,
  type tinyint NOT NULL,
  difference int NOT NULL
);

CREATE INDEX buildid ON builderrordiff (buildid);



--
-- Table: testdiff
--

CREATE TABLE testdiff (
  buildid bigint NOT NULL,
  type tinyint NOT NULL,
  difference int NOT NULL
);

CREATE INDEX buildid ON testdiff (buildid, type);



--
-- Table: build2note
--

CREATE TABLE build2note (
  buildid bigint NOT NULL,
  noteid bigint NOT NULL,
  time timestamp NOT NULL DEFAULT 'CURRENT_TIMESTAMP'
);

CREATE INDEX buildid ON build2note (buildid, noteid);

