-- 
-- Created by SQL::Translator::Producer::SQLite
-- Created on Mon Jun 30 20:17:46 2008
-- 
BEGIN TRANSACTION;


--
-- Table: build
--
CREATE TABLE build (
  id INTEGER PRIMARY KEY NOT NULL,
  siteid int(11) NOT NULL DEFAULT '0',
  projectid int(11) NOT NULL DEFAULT '0',
  stamp varchar(255) NOT NULL DEFAULT '',
  name varchar(255) NOT NULL DEFAULT '',
  type varchar(255) NOT NULL DEFAULT '',
  generator varchar(255) NOT NULL DEFAULT '',
  starttime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  endtime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  submittime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  command text NOT NULL,
  log text NOT NULL
);

CREATE INDEX siteid_build ON build (siteid, name);
CREATE INDEX projectid_build ON build (projectid);

--
-- Table: buildgroup
--
CREATE TABLE buildgroup (
  id INTEGER PRIMARY KEY NOT NULL,
  name varchar(255) NOT NULL DEFAULT '',
  projectid int(11) NOT NULL DEFAULT '0',
  starttime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  endtime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  description text NOT NULL
);

CREATE INDEX projectid_buildgroup ON buildgroup (projectid);

--
-- Table: buildgroupposition
--
CREATE TABLE buildgroupposition (
  buildgroupid int(11) NOT NULL DEFAULT '0',
  position int(11) NOT NULL DEFAULT '0',
  starttime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  endtime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00'
);

CREATE INDEX buildgroupid_buildgrouppositio ON buildgroupposition (buildgroupid);

--
-- Table: build2group
--
CREATE TABLE build2group (
  groupid int(11) NOT NULL DEFAULT '0',
  buildid INTEGER PRIMARY KEY NOT NULL DEFAULT '0'
);

CREATE INDEX groupid_build2group ON build2group (groupid);

--
-- Table: build2grouprule
--
CREATE TABLE build2grouprule (
  groupid int(11) NOT NULL DEFAULT '0',
  buildtype varchar(20) NOT NULL DEFAULT '',
  buildname varchar(255) NOT NULL DEFAULT '',
  siteid int(11) NOT NULL DEFAULT '0',
  expected tinyint(4) NOT NULL DEFAULT '0',
  starttime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  endtime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00'
);

CREATE INDEX groupid_build2grouprule ON build2grouprule (groupid);

--
-- Table: builderror
--
CREATE TABLE builderror (
  buildid int(11) NOT NULL DEFAULT '0',
  type tinyint(4) NOT NULL DEFAULT '0',
  logline int(11) NOT NULL DEFAULT '0',
  text text NOT NULL,
  sourcefile varchar(255) NOT NULL DEFAULT '',
  sourceline int(11) NOT NULL DEFAULT '0',
  precontext text NOT NULL,
  postcontext text NOT NULL,
  repeatcount int(11) NOT NULL DEFAULT '0'
);

CREATE INDEX buildid_builderror ON builderror (buildid);

--
-- Table: buildupdate
--
CREATE TABLE buildupdate (
  buildid int(11) NOT NULL DEFAULT '0',
  starttime timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  endtime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  command text NOT NULL,
  type varchar(4) NOT NULL DEFAULT '',
  status text NOT NULL
);

CREATE INDEX buildid_buildupdate ON buildupdate (buildid);

--
-- Table: configure
--
CREATE TABLE configure (
  buildid int(11) NOT NULL DEFAULT '0',
  starttime timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  endtime timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  command text NOT NULL,
  log text NOT NULL,
  status tinyint(4) NOT NULL DEFAULT '0'
);

CREATE INDEX buildid_configure ON configure (buildid);

--
-- Table: coverage
--
CREATE TABLE coverage (
  buildid int(11) NOT NULL DEFAULT '0',
  fileid int(11) NOT NULL DEFAULT '0',
  covered tinyint(4) NOT NULL DEFAULT '0',
  loctested int(11) NOT NULL DEFAULT '0',
  locuntested int(11) NOT NULL DEFAULT '0',
  branchstested int(11) NOT NULL DEFAULT '0',
  branchsuntested int(11) NOT NULL DEFAULT '0',
  functionstested int(11) NOT NULL DEFAULT '0',
  functionsuntested int(11) NOT NULL DEFAULT '0'
);

CREATE INDEX buildid_coverage ON coverage (buildid);
CREATE INDEX fileid_coverage ON coverage (fileid);

--
-- Table: coveragefile
--
CREATE TABLE coveragefile (
  id INTEGER PRIMARY KEY NOT NULL,
  fullpath varchar(255) NOT NULL DEFAULT '',
  file blob,
  crc32 int(11) DEFAULT NULL
);

CREATE INDEX fullpath_coveragefile ON coveragefile (fullpath);
CREATE INDEX crc32_coveragefile ON coveragefile (crc32);

--
-- Table: coveragefilelog
--
CREATE TABLE coveragefilelog (
  buildid int(11) NOT NULL DEFAULT '0',
  fileid int(11) NOT NULL DEFAULT '0',
  line int(11) NOT NULL DEFAULT '0',
  code varchar(10) NOT NULL DEFAULT ''
);

CREATE INDEX fileid_coveragefilelog ON coveragefilelog (fileid);
CREATE INDEX buildid_coveragefilelog ON coveragefilelog (buildid);

--
-- Table: coveragesummary
--
CREATE TABLE coveragesummary (
  buildid INTEGER PRIMARY KEY NOT NULL DEFAULT '0',
  loctested int(11) NOT NULL DEFAULT '0',
  locuntested int(11) NOT NULL DEFAULT '0'
);


--
-- Table: dynamicanalysis
--
CREATE TABLE dynamicanalysis (
  id INTEGER PRIMARY KEY NOT NULL,
  buildid int(11) NOT NULL DEFAULT '0',
  status varchar(10) NOT NULL DEFAULT '',
  checker varchar(60) NOT NULL DEFAULT '',
  name varchar(255) NOT NULL DEFAULT '',
  path varchar(255) NOT NULL DEFAULT '',
  fullcommandline varchar(255) NOT NULL DEFAULT '',
  log text NOT NULL
);

CREATE INDEX buildid_dynamicanalysis ON dynamicanalysis (buildid);

--
-- Table: dynamicanalysisdefect
--
CREATE TABLE dynamicanalysisdefect (
  dynamicanalysisid int(11) NOT NULL DEFAULT '0',
  type varchar(50) NOT NULL DEFAULT '',
  value varchar(50) NOT NULL DEFAULT ''
);

CREATE INDEX buildid_dynamicanalysisdefect ON dynamicanalysisdefect (dynamicanalysisid);

--
-- Table: image
--
CREATE TABLE image (
  id int NOT NULL,
  img longblob NOT NULL,
  extension tinytext NOT NULL,
  checksum int(11) NOT NULL
);

CREATE INDEX id_image ON image (id);
CREATE INDEX checksum_image ON image (checksum);

--
-- Table: test2image
--
CREATE TABLE test2image (
  imgid int(11) NOT NULL DEFAULT '0',
  testid int(11) NOT NULL DEFAULT '0',
  role tinytext NOT NULL,
  PRIMARY KEY (imgid, testid)
);


--
-- Table: note
--
CREATE TABLE note (
  id INTEGER PRIMARY KEY NOT NULL,
  text mediumtext NOT NULL,
  name varchar(255) NOT NULL,
  crc32 int(11) NOT NULL
);

CREATE INDEX crc32_note ON note (crc32);

--
-- Table: project
--
CREATE TABLE project (
  id INTEGER PRIMARY KEY NOT NULL,
  name varchar(255) NOT NULL DEFAULT '',
  description text NOT NULL,
  homeurl varchar(255) NOT NULL DEFAULT '',
  cvsurl varchar(255) NOT NULL DEFAULT '',
  bugtrackerurl varchar(255) NOT NULL DEFAULT '',
  documentationurl varchar(255) NOT NULL DEFAULT '',
  imageid int(11) NOT NULL DEFAULT '0',
  public tinyint(4) NOT NULL DEFAULT '1',
  coveragethreshold smallint(6) NOT NULL DEFAULT '70',
  nightlytime varchar(50) NOT NULL DEFAULT '00:00:00',
  googletracker varchar(50) NOT NULL DEFAULT '',
  emailbuildmissing tinyint(4) NOT NULL DEFAULT '0',
  emaillowcoverage tinyint(4) NOT NULL DEFAULT '0',
  emailtesttimingchanged tinyint(4) NOT NULL DEFAULT '0',
  emailbrokensubmission tinyint(4) NOT NULL DEFAULT '1',
  cvsviewertype varchar(10) DEFAULT NULL,
  testtimestd float(3,1) DEFAULT '4.0',
  testtimestdthreshold float(3,1) DEFAULT '1.0',
  showtesttime tinyint(4) DEFAULT '0'
);


--
-- Table: site
--
CREATE TABLE site (
  id INTEGER PRIMARY KEY NOT NULL,
  name varchar(255) NOT NULL DEFAULT '',
  ip varchar(255) NOT NULL DEFAULT '',
  latitude varchar(10) NOT NULL DEFAULT '',
  longitude varchar(10) NOT NULL DEFAULT ''
);


--
-- Table: siteinformation
--
CREATE TABLE siteinformation (
  siteid int(11) NOT NULL,
  timestamp timestamp NOT NULL DEFAULT '0001-01-01 00:00:00',
  processoris64bits tinyint(4) NOT NULL DEFAULT '-1',
  processorvendor varchar(255) NOT NULL DEFAULT 'NA',
  processorvendorid varchar(255) NOT NULL DEFAULT 'NA',
  processorfamilyid int(11) NOT NULL DEFAULT '-1',
  processormodelid int(11) NOT NULL DEFAULT '-1',
  processorcachesize int(11) NOT NULL DEFAULT '-1',
  numberlogicalcpus tinyint(4) NOT NULL DEFAULT '-1',
  numberphysicalcpus tinyint(4) NOT NULL DEFAULT '-1',
  totalvirtualmemory int(11) NOT NULL DEFAULT '-1',
  totalphysicalmemory int(11) NOT NULL DEFAULT '-1',
  logicalprocessorsperphysical int(11) NOT NULL DEFAULT '-1',
  processorclockfrequency int(11) NOT NULL DEFAULT '-1',
  description varchar(255) NOT NULL DEFAULT 'NA'
);

CREATE INDEX siteid_siteinformation ON siteinformation (siteid, timestamp);

--
-- Table: buildinformation
--
CREATE TABLE buildinformation (
  buildid INTEGER PRIMARY KEY NOT NULL,
  osname varchar(255) NOT NULL,
  osplatform varchar(255) NOT NULL,
  osrelease varchar(255) NOT NULL,
  osversion varchar(255) NOT NULL,
  compilername varchar(255) NOT NULL,
  compilerversion varchar(20) NOT NULL
);


--
-- Table: site2user
--
CREATE TABLE site2user (
  siteid int(11) NOT NULL DEFAULT '0',
  userid int(11) NOT NULL DEFAULT '0'
);

CREATE INDEX siteid_site2user ON site2user (siteid);
CREATE INDEX userid_site2user ON site2user (userid);

--
-- Table: test
--
CREATE TABLE test (
  id INTEGER PRIMARY KEY NOT NULL,
  crc32 int(11) NOT NULL,
  name varchar(255) NOT NULL DEFAULT '',
  path varchar(255) NOT NULL DEFAULT '',
  command text NOT NULL,
  details text NOT NULL,
  output text NOT NULL
);

CREATE INDEX crc32_test ON test (crc32);
CREATE INDEX name_test ON test (name);

--
-- Table: build2test
--
CREATE TABLE build2test (
  buildid int(11) NOT NULL DEFAULT '0',
  testid int(11) NOT NULL DEFAULT '0',
  status varchar(10) NOT NULL DEFAULT '',
  time float(7,2) NOT NULL DEFAULT '0.00',
  timemean float(7,2) NOT NULL DEFAULT '0.00',
  timestd float(7,2) NOT NULL DEFAULT '0.00',
  timestatus tinyint(4) NOT NULL DEFAULT '0'
);

CREATE INDEX buildid_build2test ON build2test (buildid);
CREATE INDEX testid_build2test ON build2test (testid);
CREATE INDEX status_build2test ON build2test (status);
CREATE INDEX timestatus_build2test ON build2test (timestatus);

--
-- Table: updatefile
--
CREATE TABLE updatefile (
  buildid int(11) NOT NULL DEFAULT '0',
  filename varchar(255) NOT NULL DEFAULT '',
  checkindate timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  author varchar(255) NOT NULL DEFAULT '',
  email varchar(255) NOT NULL DEFAULT '',
  log text NOT NULL,
  revision varchar(20) NOT NULL DEFAULT '0',
  priorrevision varchar(20) NOT NULL DEFAULT '0'
);

CREATE INDEX buildid_updatefile ON updatefile (buildid);

--
-- Table: user
--
CREATE TABLE user (
  id INTEGER PRIMARY KEY NOT NULL,
  email varchar(255) NOT NULL DEFAULT '',
  password varchar(40) NOT NULL DEFAULT '',
  firstname varchar(40) NOT NULL DEFAULT '',
  lastname varchar(40) NOT NULL DEFAULT '',
  institution varchar(255) NOT NULL DEFAULT '',
  admin tinyint(4) NOT NULL DEFAULT '0'
);


--
-- Table: user2project
--
CREATE TABLE user2project (
  userid int(11) NOT NULL DEFAULT '0',
  projectid int(11) NOT NULL DEFAULT '0',
  role int(11) NOT NULL DEFAULT '0',
  cvslogin varchar(50) NOT NULL DEFAULT '',
  emailtype tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (userid, projectid)
);


--
-- Table: buildnote
--
CREATE TABLE buildnote (
  buildid int(11) NOT NULL,
  userid int(11) NOT NULL,
  note mediumtext NOT NULL,
  timestamp datetime NOT NULL,
  status tinyint(4) NOT NULL DEFAULT '0'
);

CREATE INDEX buildid_buildnote ON buildnote (buildid);

--
-- Table: repositories
--
CREATE TABLE repositories (
  id INTEGER PRIMARY KEY NOT NULL,
  url varchar(255) NOT NULL
);


--
-- Table: project2repositories
--
CREATE TABLE project2repositories (
  projectid int(11) NOT NULL,
  repositoryid int(11) NOT NULL,
  PRIMARY KEY (projectid, repositoryid)
);


--
-- Table: testmeasurement
--
CREATE TABLE testmeasurement (
  testid bigint(20) NOT NULL,
  name varchar(70) NOT NULL,
  type varchar(70) NOT NULL,
  value text NOT NULL
);

CREATE INDEX testid_testmeasurement ON testmeasurement (testid);

--
-- Table: dailyupdate
--
CREATE TABLE dailyupdate (
  id bigint NOT NULL,
  projectid int(11) NOT NULL,
  date date NOT NULL,
  command text NOT NULL,
  type varchar(4) NOT NULL DEFAULT '',
  status tinyint(4) NOT NULL DEFAULT '0'
);

CREATE INDEX buildid_dailyupdate ON dailyupdate (id);

--
-- Table: dailyupdatefile
--
CREATE TABLE dailyupdatefile (
  dailyupdateid int(11) NOT NULL DEFAULT '0',
  filename varchar(255) NOT NULL DEFAULT '',
  checkindate timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  author varchar(255) NOT NULL DEFAULT '',
  log text NOT NULL,
  revision varchar(10) NOT NULL DEFAULT '0',
  priorrevision varchar(10) NOT NULL DEFAULT '0'
);

CREATE INDEX buildid_dailyupdatefile ON dailyupdatefile (dailyupdateid);

--
-- Table: builderrordiff
--
CREATE TABLE builderrordiff (
  buildid bigint(20) NOT NULL,
  type tinyint(4) NOT NULL,
  difference int(11) NOT NULL
);

CREATE INDEX buildid_builderrordiff ON builderrordiff (buildid);

--
-- Table: testdiff
--
CREATE TABLE testdiff (
  buildid bigint(20) NOT NULL,
  type tinyint(4) NOT NULL,
  difference int(11) NOT NULL
);

CREATE INDEX buildid_testdiff ON testdiff (buildid, type);

--
-- Table: build2note
--
CREATE TABLE build2note (
  buildid bigint(20) NOT NULL,
  noteid bigint(20) NOT NULL,
  time timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP
);

CREATE INDEX buildid_build2note ON build2note (buildid, noteid);

COMMIT;
